import os
import pygsheets
import pandas as pd
import pymysql
from pymysql import Error
from datetime import date,datetime, timedelta, timezone
from tool import *
from db_connet import *


__directory__ = os.path.dirname(os.path.abspath(__file__))
__LogFileName__ = datetime.today().strftime("%Y%m%d")+'_revenue.txt'


def logTxt(msg):
    filename = f"{__directory__+'/logs/'+__LogFileName__}"
    f = open(filename, "a")
    f.write("{0} -- {1}\n".format(now(), msg))
    f.close()


# 將日期加入幾天
def add_day(time,num):
    add_num = timedelta(num)
    return time + add_num

# 日期格式化輸出
def format_day(time):
    return time.strftime("%Y-%m-%d")

# 針對來源日期進行處理
def orign_day(time):
    if(time == ''):
        return ""
    time = datetime.strptime(time, '%Y-%m-%d')
    return format_day(add_day(time,1))
    
# 輸出起訖日期
def datelist(beginDate, endDate):
    date=[datetime.strftime(x,'%Y/%-m/%-d') for x in list(pd.date_range(start=beginDate, end=endDate))]
    return date

# 補滿list元素
def replenish(num):
    total = [0,0,0,0,0,0,0,0,0]
    for i in range(0,len(total)-len(num)):
        num.append('0')

    for k,i in enumerate(num):
        if num[k] == '':
            num[k] = '0'

    return num

# 過濾特殊符號 << 字元處理
def decompose(data):
    s = [',','%']
    return s.count(data) == 0

# 過濾特殊符號
def str_filter(data):
    s = []
    for k,v in enumerate(data):
        str = filter(decompose, v)
        s.append(''.join(str)) 
    return s

# 日期格式轉換 (2023/1/13 => 2023-01-13)
def trans_day(date):
    d = date.split('/')
    return d[0]+'-'+d[1].zfill(2)+'-'+d[2].zfill(2)


gc = pygsheets.authorize(service_file = r'helical-tendril-369603-bb137410dd4e.json')
sht = gc.open_by_url(
'https://docs.google.com/spreadsheets/d/1YaFoqKSJOaC_30h-frY5bK5mFrQBMC5SiL_T41-Dc-4/'
)
data = sht.worksheet_by_title("每日營收")

today = datetime.now().strftime("%Y-%m-%d %H:%M:%S")

# 各通路項目
server_name_ary = []
server_name_list = ['G1','P1','Y1','AA1','AG1','AN1','AT1','AZ1','BE1','BH1','BK1','BP1','BU1','BX1','CA1','CD1','CG1','CM1']
for i in server_name_list:
    n = data.cell(f'{i}')
    server_name_ary.append(n.value)

num_range = [
    ['G','O'],['P','X'],['Y','Z'],['AA','AF'],['AG','AM'],['AN','AS'],['AT','AY'],['AZ','BD'],['BE','BG'],['BH','BJ'],['BK','BO'],['BP','BT'],['BU','BW'],['BX','BZ'],['CA','CC'],['CD','CF'],['CG','CI'],['CM','CN'],
]
def call_inster_sql(key,date,server_name_ary,range_date,today):
    switcher={
# 官網
            0:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `discount`, `discount_percentage`, `freight`, `flow`, `order_price`, `received_cash`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}', '{range_date[5]}', '{range_date[6]}', '{range_date[7]}', '{range_date[8]}', '{today}')",
# 彌月正式
            1:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `discount`, `discount_percentage`, `freight`, `flow`, `order_price`, `received_cash`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}','{range_date[5]}', '{range_date[6]}', '{range_date[7]}', '{range_date[8]}', '{today}')",
# 彌月試吃
            2:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}', '{today}')",
# 通路訂單
            3:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `discount`, `discount_percentage`, `order_price`, `received_cash`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}','{range_date[4]}', '{range_date[5]}', '{today}')",
#特殊團媽訂單
            4:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `discount`, `discount_percentage`, `freight`, `order_price`, `received_cash`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}','{range_date[5]}', '{range_date[6]}', '{today}')",
#合作廠商訂單
            5:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `discount`, `discount_percentage`, `order_price`, `received_cash`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}', '{range_date[5]}','{today}')",
#境外訂單
            6:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `discount`, `discount_percentage`, `order_price`, `received_cash`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}','{range_date[5]}', '{today}')",
#港澳訂單
            7:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `discount`, `discount_percentage`, `order_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}','{today}')",
#台中美村門市 
            8:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{today}')",
#臺北永康門市
            9:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{today}')",
#大里 
            10:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `discount`, `discount_percentage`, `order_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}','{today}')",
#烏日
            11:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `discount`, `discount_percentage`, `order_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{range_date[3]}', '{range_date[4]}','{today}')",
#快閃櫃(板橋大遠百)
            12:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{today}')",
#快閃櫃(高雄夢時代)
            13:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{today}')",
#快閃櫃(桃園台茂)
            14:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{today}')",
#快閃櫃(林口三井)
            15:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{today}')",
#快閃櫃(台北迪化)
            16:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `cust_price`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}' , '{range_date[2]}', '{today}')",
#磨石子
            17:f"INSERT INTO `performance_report`(`id`, `date`, `service_name`, `quantity`, `income`, `created_at`) VALUES (NULL,'{date}', '{server_name_ary[key]}', '{range_date[0]}', '{range_date[1]}', '{today}')",

    }
    return switcher.get(key,"Null value")

def call_update_sql(key,date,server_name_ary,range_date,today):
    switcher={
# 官網
            0:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
# 彌月正式
            1:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
# 彌月試吃
            2:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
# 通路訂單
            3:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#特殊團媽訂單
            4:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#合作廠商訂單
            5:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#境外訂單
            6:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#港澳訂單
            7:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#台中美村門市 
            8:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#臺北永康門市
            9:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#大里 
            10:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#烏日
            11:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#快閃櫃(板橋大遠百)
            12:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#快閃櫃(高雄夢時代)
            13:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#快閃櫃(桃園台茂)
            14:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#快閃櫃(林口三井)
            15:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#快閃櫃(台北迪化)
            16:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",
#磨石子
            17:f"UPDATE `performance_report` set `quantity` = '{range_date[0]}', `income` = '{range_date[1]}', `cust_price` = '{range_date[2]}', `discount` = '{range_date[3]}', `discount_percentage` = '{range_date[4]}', `freight` = '{range_date[5]}', `flow` = '{range_date[6]}', `order_price` = '{range_date[7]}', `received_cash` = '{range_date[8]}' WHERE date = '{date}' and service_name = '{server_name_ary[key]}'",

    }
    return switcher.get(key,"Null value")




########################################################
# 自定義日期
# date_range = datelist('2023/01/27','2023/01/30')
########################################################

date_block = get_ago_date(1)
date_range = datelist(date_block['start'],date_block['end'])

for day in date_range:
    path = data.find(f'{day}')[0].label[1:10]
    day = trans_day(day)
    logTxt('==== start ====')
    count = rowcount(f"SELECT 1 FROM `performance_report` WHERE date ='{day}'",'lake')
    logTxt(f"SELECT 1 FROM `performance_report` WHERE date ='{day}'")
    for k,i in enumerate(num_range):
        range_date = data.get_values(f'{i[0]}{path}',f'{i[1]}{path}')[0]
        range_date = replenish(range_date)
        range_date = str_filter(range_date)
        if(count):
            sql = call_update_sql(k,day,server_name_ary,range_date,today)
        else:
            sql = call_inster_sql(k,day,server_name_ary,range_date,today)
        logTxt(sql)
        query_db(sql,'lake')
    logTxt('==== end ====')